// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.15.0
// source: logevents.sql

package database

import (
	"context"
	"database/sql"
	"time"
)

const logEventAnonymize = `-- name: LogEventAnonymize :exec
UPDATE log_events
SET message = '· Kommentar wurde anonymisiert'
WHERE booking_id = ? AND user_id <> ''
`

func (q *Queries) LogEventAnonymize(ctx context.Context, bookingID int32) error {
	_, err := q.db.ExecContext(ctx, logEventAnonymize, bookingID)
	return err
}

const logEventCreate = `-- name: LogEventCreate :exec
INSERT INTO log_events (booking_id,  user_id, message)
VALUES (?, ?, ?)
`

type LogEventCreateParams struct {
	BookingID int32
	UserID    sql.NullString
	Message   string
}

func (q *Queries) LogEventCreate(ctx context.Context, arg LogEventCreateParams) error {
	_, err := q.db.ExecContext(ctx, logEventCreate, arg.BookingID, arg.UserID, arg.Message)
	return err
}

const logEventIndex = `-- name: LogEventIndex :many
SELECT log_events.created_at, log_events.message, COALESCE(users.name, log_events.user_id, '')
FROM log_events
LEFT JOIN users ON users.id = log_events.user_id
WHERE booking_id = ?
ORDER BY log_events.created_at DESC, log_events.id DESC
`

type LogEventIndexRow struct {
	CreatedAt time.Time
	Message   string
	Name      string
}

func (q *Queries) LogEventIndex(ctx context.Context, bookingID int32) ([]LogEventIndexRow, error) {
	rows, err := q.db.QueryContext(ctx, logEventIndex, bookingID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []LogEventIndexRow
	for rows.Next() {
		var i LogEventIndexRow
		if err := rows.Scan(&i.CreatedAt, &i.Message, &i.Name); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
